/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import java.util.Locale;

//import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacUltrasoundCommonLinearMeasurements;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EchocardiographyCommonMeasurements;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_OrificeFlowProperties;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;


/**
 * This class represents EchocardiographyCongenital - CID12218
 */
public class EchocardiographyCongenital_CID12218 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Object of EchocardiographyCommonMeasurements_CID12220
	 */
	private EchocardiographyCommonMeasurements_CID12220 objEchocardiographyCommonMeasurementsCID12220;
	/**
	 * Object of OrificeFlowProperties_CID12222
	 */
	private OrificeFlowProperties_CID12222 objOrificeFlowPropertiesCID12222;
	/**
	 * Object of CardiacUltrasoundCommonLinearMeasurements_CID12250
	 */
	private CardiacUltrasoundCommonLinearMeasurements_CID12250 objCardiacUltrasoundCommonLinearMeasurementsCID12250;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new EchocardiographyCongenital_CID12218 Template 
	 */
	public EchocardiographyCongenital_CID12218()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the value for EchocardiographyCongenital
	 * @param enumEchocardiographyCongenital Object of EnumCM_EchocardiographyCongenital.
	 */
	public void setEchocardiographyCongenital(Enum enumValue)
	{
		 if(enumValue instanceof EnumCM_EchocardiographyCommonMeasurements)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_EchocardiographyCommonMeasurements new_enumEchocardiographyCommonMeasurements = (EnumCM_EchocardiographyCommonMeasurements) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objEchocardiographyCommonMeasurementsCID12220)
				this.objEchocardiographyCommonMeasurementsCID12220 = new EchocardiographyCommonMeasurements_CID12220();
				this.objEchocardiographyCommonMeasurementsCID12220.setEchocardiographyCommonMeasurements(new_enumEchocardiographyCommonMeasurements);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objEchocardiographyCommonMeasurementsCID12220.getCodeMeaning();
				this.strCodeValue = objEchocardiographyCommonMeasurementsCID12220.getCodeValue();
				this.strCodingSchemeDesignator = objEchocardiographyCommonMeasurementsCID12220.getCodingSchemeDesignator();
			}
		 else if(enumValue instanceof EnumCM_OrificeFlowProperties)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_OrificeFlowProperties new_enumOrificeFlowProperties = (EnumCM_OrificeFlowProperties) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objOrificeFlowPropertiesCID12222)
				this.objOrificeFlowPropertiesCID12222 = new OrificeFlowProperties_CID12222();
				this.objOrificeFlowPropertiesCID12222.setOrificeFlowProperties(new_enumOrificeFlowProperties);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objOrificeFlowPropertiesCID12222.getCodeMeaning();
				this.strCodeValue = objOrificeFlowPropertiesCID12222.getCodeValue();
				this.strCodingSchemeDesignator = objOrificeFlowPropertiesCID12222.getCodingSchemeDesignator();
				this.strSNOMEDCTID = objOrificeFlowPropertiesCID12222.getSNOMEDCTID();
			}
		 else if(enumValue instanceof EnumCM_CardiacUltrasoundCommonLinearMeasurements)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_CardiacUltrasoundCommonLinearMeasurements new_enumCardiacUltrasoundCommonLinearMeasurements = (EnumCM_CardiacUltrasoundCommonLinearMeasurements) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objCardiacUltrasoundCommonLinearMeasurementsCID12250)
				this.objCardiacUltrasoundCommonLinearMeasurementsCID12250 = new CardiacUltrasoundCommonLinearMeasurements_CID12250();
				this.objCardiacUltrasoundCommonLinearMeasurementsCID12250.setCardiacUltrasoundCommonLinearMeasurements(new_enumCardiacUltrasoundCommonLinearMeasurements);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objCardiacUltrasoundCommonLinearMeasurementsCID12250.getCodeMeaning();
				this.strCodeValue = objCardiacUltrasoundCommonLinearMeasurementsCID12250.getCodeValue();
				this.strCodingSchemeDesignator = objCardiacUltrasoundCommonLinearMeasurementsCID12250.getCodingSchemeDesignator();
				this.strSNOMEDCTID = objCardiacUltrasoundCommonLinearMeasurementsCID12250.getSNOMEDCTID();
			}
	
		
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
				objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
	}
}
